;;;; srfi-19-date.comparator.scm  -*- Scheme -*-
;;;; Kon Lovett, Dec '21

(module srfi-19-date.comparator

(;export
  date-hash
  make-date-comparator)

(import scheme
  (chicken base)
  (chicken type)
  (only (chicken bitwise) bitwise-xor)
  (only (srfi 128) number-hash make-comparator hash-salt hash-bound)
  (only srfi-19-date date->julian-day date? date=? date<? check-date))

;;;

(include-relative "srfi-19-common.types")

(: date-hash (date --> integer))
(: make-date-comparator (--> (struct comparator)))

;;;

(define (limit-hash hsh)
  (modulo (bitwise-xor hsh (hash-salt)) (hash-bound)) )

(define (date-hash dat)
  (limit-hash (number-hash (date->julian-day dat))) )

(define (make-date-comparator)
  (make-comparator date? date=? date<? date-hash) )

) ;module srfi-19-date.comparator
